#define	YYLEXTYPE	int
#line 4 "expr.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <math.h>

#include "expr.h"

#define xstrdup	strdup

#ifndef TRUE
#define TRUE	1
#define FALSE	0
#endif

double eval_val;
BOOL no_err;
BOOL var_assigned = FALSE;
double acc;

static char rcs_id[] =
	"$Id: expr.y 1.2 1996/04/14 04:19:23 hirofumi Exp hirofumi $";

static int eval_end;
static char *eval_s = 0;

int yyerror(char *s);
int	yylex(void);

#if 1

#define mod(a,b)	(fmod((a),(b)))
#define and(a,b)	(double)((long)(a) & (long)(b))
#define or(a,b)		(double)((long)(a) | (long)(b))
#define xor(a,b)	(double)((long)(a) ^ (long)(b))
#define power(a,b)	(pow((a),(b)))
#define shl(a,b)	(double)((long)(a) << (long)(b))
#define shr(a,b)	(double)((long)(a) >> (long)(b))
#define not(a)		(double)(~(long)(a))

#else	/* RTYPE != double */

#define mod(a,b)	((a) % (b))
#define and(a,b)	((a) & (b))
#define or(a,b)		((a) | (b))
#define xor(a,b)	((a) ^ (b))
#define shl(a,b)	((a) << (b))
#define shr(a,b)	((a) >> (b))
#define not(a)		(~(a))

double power(double a, double b)
{
	/* skimp.... */
	double l = a, r;
	
	if (b < 0) {
		return 0;
	}else if (b == 0) {
		return 1;
	}else if (a == 0) {
		if (b >= 0) {
			return 0;
		}
		yyerror("pow ?");
	}else{
		for (r = 1; r < b; ++r) {
			l *= a;
		}
	}
	return l;
}

#endif	/* end of double != double */

double preinc(char* name)
{
	return assign_variable(name, eval_variable(name) + 1);
}

double predec(char* name)
{
	return assign_variable(name, eval_variable(name) - 1);
}

double postinc(char* name)
{
	return acc = assign_variable(name, eval_variable(name) + 1) - 1;
}

double postdec(char* name)
{
	return acc = assign_variable(name, eval_variable(name) - 1) + 1;
}

int yyerror(char *s)
{
	no_err = FALSE;
	//fprintf(stderr, "%s\n", s);
	HandleError(s);
	return -1;
}

#include "expr.h"
YYSTYPE	*yyasp, yylval, yyval;
extern	void	yydef();
char	yyerrflag = 0;
#define	yyerrok	yyerrflag = 0
int	yytoken = 0;
#define	yyclearin	yytoken = 0
#include <setjmp.h>
jmp_buf	yyjmp;
#define	YYACCEPT	longjmp(yyjmp, 1)
#define	YYABORT	longjmp(yyjmp, 2)
#define	yya1	yydef
#define	yya2	yydef
void	yya3()
#line 144 "expr.y"
{ 
				eval_val = yyasp[1].value; 
			}
void	yya4()
#line 147 "expr.y"
{ yyerrok; }
void	yya5()
#line 151 "expr.y"
{ var_assigned = FALSE; yyval.value = yyasp[0].value; }
void	yya6()
#line 152 "expr.y"
{ yyval.value = -yyasp[0].value; }
void	yya7()
#line 153 "expr.y"
{ yyval.value = yyasp[0].value; }
void	yya8()
#line 155 "expr.y"
{ yyval.value = preinc(yyasp[0].name); }
void	yya9()
#line 156 "expr.y"
{ yyval.value = predec(yyasp[0].name); }
void	yya10()
#line 157 "expr.y"
{ yyval.value = postinc(yyasp[1].name); }
void	yya11()
#line 158 "expr.y"
{ yyval.value = postdec(yyasp[1].name); }
void	yya12()
#line 160 "expr.y"
{ yyval.value = !(yyasp[0].value); }
void	yya13()
#line 161 "expr.y"
{ yyval.value = not(yyasp[0].value); }
void	yya14()
#line 163 "expr.y"
{ yyval.value = yyasp[2].value + yyasp[0].value; }
void	yya15()
#line 164 "expr.y"
{ yyval.value = yyasp[2].value - yyasp[0].value; }
void	yya16()
#line 165 "expr.y"
{ yyval.value = yyasp[2].value * yyasp[0].value; }
void	yya17()
#line 166 "expr.y"
{ yyval.value = yyasp[2].value / yyasp[0].value; }
void	yya18()
#line 167 "expr.y"
{ yyval.value = mod(yyasp[2].value, yyasp[0].value); }
void	yya19()
#line 168 "expr.y"
{ yyval.value = and(yyasp[2].value, yyasp[0].value); }
void	yya20()
#line 169 "expr.y"
{ yyval.value = or(yyasp[2].value, yyasp[0].value); }
void	yya21()
#line 170 "expr.y"
{ yyval.value = xor(yyasp[2].value, yyasp[0].value); }
void	yya22()
#line 171 "expr.y"
{ yyval.value = shl(yyasp[2].value, yyasp[0].value); }
void	yya23()
#line 172 "expr.y"
{ yyval.value = shr(yyasp[2].value, yyasp[0].value); }
void	yya24()
#line 174 "expr.y"
{ yyval.value = power(yyasp[2].value, yyasp[0].value); }
void	yya25()
#line 176 "expr.y"
{ yyval.value = yyasp[2].value && yyasp[0].value; }
void	yya26()
#line 177 "expr.y"
{ yyval.value = yyasp[2].value || yyasp[0].value; }
void	yya27()
#line 178 "expr.y"
{ yyval.value = yyasp[2].value == yyasp[0].value; }
void	yya28()
#line 179 "expr.y"
{ yyval.value = yyasp[2].value != yyasp[0].value; }
void	yya29()
#line 180 "expr.y"
{ yyval.value = yyasp[2].value < yyasp[0].value; }
void	yya30()
#line 181 "expr.y"
{ yyval.value = yyasp[2].value <= yyasp[0].value; }
void	yya31()
#line 182 "expr.y"
{ yyval.value = yyasp[2].value > yyasp[0].value; }
void	yya32()
#line 183 "expr.y"
{ yyval.value = yyasp[2].value >= yyasp[0].value; }
void	yya33()
#line 184 "expr.y"
{ 
				if (yyasp[4].value)
					yyval.value = yyasp[2].value;
				else
					yyval.value = yyasp[0].value;
			}
void	yya34()
#line 190 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, yyasp[0].value);
			}
void	yya35()
#line 193 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, eval_variable(yyasp[2].name) + yyasp[0].value);
			}
void	yya36()
#line 196 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, eval_variable(yyasp[2].name) - yyasp[0].value);
			}
void	yya37()
#line 199 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, eval_variable(yyasp[2].name) * yyasp[0].value);
			}
void	yya38()
#line 202 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, eval_variable(yyasp[2].name) / yyasp[0].value);
			}
void	yya39()
#line 205 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, mod(eval_variable(yyasp[2].name), yyasp[0].value));
			}
void	yya40()
#line 208 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, and(eval_variable(yyasp[2].name), yyasp[0].value));
			}
void	yya41()
#line 211 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, xor(eval_variable(yyasp[2].name), yyasp[0].value));
			}
void	yya42()
#line 214 "expr.y"
{
				yyval.value = assign_variable(yyasp[2].name, or(eval_variable(yyasp[2].name), yyasp[0].value));
			}
void	yya43()
#line 217 "expr.y"
{
				yyval.value = eval_variable(yyasp[0].name);
			}
void	yya44()
#line 220 "expr.y"
{ }
void	yya45()
#line 221 "expr.y"
{
				 yyval.value = yyasp[1].value;
		}
#ifdef	YYDEBUG
#define	YYDISPLAY
char	*yypnames[] = {
"S' : line",
"line :",
"line : line EOL",
"line : line expr EOL",
"line : line error EOL",
"expr : expr , expr",
"expr : - expr",
"expr : + expr",
"expr : INC VARIABLE",
"expr : DEC VARIABLE",
"expr : VARIABLE INC",
"expr : VARIABLE DEC",
"expr : ! expr",
"expr : ~ expr",
"expr : expr + expr",
"expr : expr - expr",
"expr : expr * expr",
"expr : expr / expr",
"expr : expr % expr",
"expr : expr & expr",
"expr : expr | expr",
"expr : expr ^ expr",
"expr : expr SHL expr",
"expr : expr SHR expr",
"expr : expr POWER expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : expr IDN expr",
"expr : expr DIF expr",
"expr : expr < expr",
"expr : expr LEQ expr",
"expr : expr > expr",
"expr : expr GEQ expr",
"expr : expr ? expr : expr",
"expr : VARIABLE = expr",
"expr : VARIABLE PLEQ expr",
"expr : VARIABLE MIEQ expr",
"expr : VARIABLE MULEQ expr",
"expr : VARIABLE DIVEQ expr",
"expr : VARIABLE MODEQ expr",
"expr : VARIABLE ANDEQ expr",
"expr : VARIABLE XOREQ expr",
"expr : VARIABLE OREQ expr",
"expr : VARIABLE",
"expr : Y_NUMBER",
"expr : ( expr )",
};
#endif
#ifdef	YYDISPLAY
char	*yytnames[] = {
	"EOF",
	"error",
	"VARIABLE",
	"Y_NUMBER",
	"EOL",
	"PLEQ",
	"MIEQ",
	"MULEQ",
	"DIVEQ",
	"MODEQ",
	"INC",
	"DEC",
	"POWER",
	"SHL",
	"SHR",
	"ANDEQ",
	"XOREQ",
	"OREQ",
	"OR",
	"AND",
	"IDN",
	"DIF",
	"LEQ",
	"GEQ",
	"UNARY",
};
#endif
typedef	struct {
	YYLEXTYPE	input;
	short	num;
} YYACT;
void (*yya[])() = {
	0,
	yya1,
	yya2,
	yya3,
	yya4,
	yya5,
	yya6,
	yya7,
	yya8,
	yya9,
	yya10,
	yya11,
	yya12,
	yya13,
	yya14,
	yya15,
	yya16,
	yya17,
	yya18,
	yya19,
	yya20,
	yya21,
	yya22,
	yya23,
	yya24,
	yya25,
	yya26,
	yya27,
	yya28,
	yya29,
	yya30,
	yya31,
	yya32,
	yya33,
	yya34,
	yya35,
	yya36,
	yya37,
	yya38,
	yya39,
	yya40,
	yya41,
	yya42,
	yya43,
	yya44,
	yya45,
};
YYACT	yyia[] = {
	0,	20001,	/* 0 */
	0,	-1,	/* 1 */
	YYEOF,	20000,
	YYERR,	14,
	EOL,	29,
	VARIABLE,	16,
	Y_NUMBER,	28,
	'+',	30,
	'-',	32,
	'(',	34,
	INC,	36,
	DEC,	38,
	'!',	40,
	'~',	42,
	0,	-1,	/* 2 */
	EOL,	67,
	0,	20043,	/* 3 */
	'=',	68,
	PLEQ,	70,
	MIEQ,	72,
	MULEQ,	74,
	DIVEQ,	76,
	MODEQ,	78,
	INC,	80,
	DEC,	81,
	ANDEQ,	82,
	XOREQ,	84,
	OREQ,	86,
	0,	20044,	/* 4 */
	0,	20002,	/* 5 */
	0,	-1,	/* 6 */
	YYLNK,	5,
	0,	-1,	/* 7 */
	YYLNK,	5,
	0,	-1,	/* 8 */
	YYLNK,	5,
	0,	-1,	/* 9 */
	VARIABLE,	93,
	0,	-1,	/* 10 */
	VARIABLE,	94,
	0,	-1,	/* 11 */
	YYLNK,	5,
	0,	-1,	/* 12 */
	YYLNK,	5,
	0,	-1,	/* 13 */
	EOL,	97,
	',',	122,
	'?',	124,
	OR,	126,
	AND,	128,
	'<',	112,
	'>',	114,
	IDN,	130,
	DIF,	132,
	LEQ,	134,
	GEQ,	136,
	'|',	110,
	'^',	138,
	'&',	108,
	'+',	98,
	'-',	100,
	'*',	102,
	'/',	104,
	'%',	106,
	SHL,	118,
	SHR,	120,
	POWER,	116,
	0,	20004,	/* 14 */
	0,	-1,	/* 15 */
	YYLNK,	5,
	0,	-1,	/* 16 */
	YYLNK,	5,
	0,	-1,	/* 17 */
	YYLNK,	5,
	0,	-1,	/* 18 */
	YYLNK,	5,
	0,	-1,	/* 19 */
	YYLNK,	5,
	0,	-1,	/* 20 */
	YYLNK,	5,
	0,	20010,	/* 21 */
	0,	20011,	/* 22 */
	0,	-1,	/* 23 */
	YYLNK,	5,
	0,	-1,	/* 24 */
	YYLNK,	5,
	0,	-1,	/* 25 */
	YYLNK,	5,
	0,	20007,	/* 26 */
	0,	20006,	/* 27 */
	0,	-1,	/* 28 */
	')',	158,
	YYLNK,	46,
	0,	20008,	/* 29 */
	0,	20009,	/* 30 */
	0,	20012,	/* 31 */
	0,	20013,	/* 32 */
	0,	20003,	/* 33 */
	0,	-1,	/* 34 */
	YYLNK,	5,
	0,	-1,	/* 35 */
	YYLNK,	5,
	0,	-1,	/* 36 */
	YYLNK,	5,
	0,	-1,	/* 37 */
	YYLNK,	5,
	0,	-1,	/* 38 */
	YYLNK,	5,
	0,	-1,	/* 39 */
	YYLNK,	5,
	0,	-1,	/* 40 */
	YYLNK,	5,
	0,	-1,	/* 41 */
	YYLNK,	5,
	0,	-1,	/* 42 */
	YYLNK,	5,
	0,	-1,	/* 43 */
	YYLNK,	5,
	0,	-1,	/* 44 */
	YYLNK,	5,
	0,	-1,	/* 45 */
	YYLNK,	5,
	0,	-1,	/* 46 */
	YYLNK,	5,
	0,	-1,	/* 47 */
	YYLNK,	5,
	0,	-1,	/* 48 */
	YYLNK,	5,
	0,	-1,	/* 49 */
	YYLNK,	5,
	0,	-1,	/* 50 */
	YYLNK,	5,
	0,	-1,	/* 51 */
	YYLNK,	5,
	0,	-1,	/* 52 */
	YYLNK,	5,
	0,	-1,	/* 53 */
	YYLNK,	5,
	0,	-1,	/* 54 */
	YYLNK,	5,
	0,	20034,	/* 55 */
	YYLNK,	47,
	0,	20035,	/* 56 */
	YYLNK,	47,
	0,	20036,	/* 57 */
	YYLNK,	47,
	0,	20037,	/* 58 */
	YYLNK,	47,
	0,	20038,	/* 59 */
	YYLNK,	47,
	0,	20039,	/* 60 */
	YYLNK,	47,
	0,	20040,	/* 61 */
	YYLNK,	47,
	0,	20041,	/* 62 */
	YYLNK,	47,
	0,	20042,	/* 63 */
	YYLNK,	47,
	0,	20045,	/* 64 */
	0,	20014,	/* 65 */
	YYLNK,	61,
	0,	20015,	/* 66 */
	YYLNK,	61,
	0,	20016,	/* 67 */
	YYLNK,	64,
	0,	20017,	/* 68 */
	YYLNK,	64,
	0,	20018,	/* 69 */
	YYLNK,	64,
	0,	20019,	/* 70 */
	YYLNK,	59,
	0,	20020,	/* 71 */
	YYLNK,	57,
	0,	20029,	/* 72 */
	YYLNK,	56,
	0,	20031,	/* 73 */
	YYLNK,	56,
	0,	20024,	/* 74 */
	0,	20022,	/* 75 */
	POWER,	116,
	0,	20023,	/* 76 */
	POWER,	116,
	0,	20005,	/* 77 */
	YYLNK,	47,
	0,	-1,	/* 78 */
	':',	201,
	YYLNK,	46,
	0,	20026,	/* 79 */
	YYLNK,	49,
	0,	20025,	/* 80 */
	YYLNK,	50,
	0,	20027,	/* 81 */
	YYLNK,	56,
	0,	20028,	/* 82 */
	YYLNK,	56,
	0,	20030,	/* 83 */
	YYLNK,	56,
	0,	20032,	/* 84 */
	YYLNK,	56,
	0,	20021,	/* 85 */
	YYLNK,	58,
	0,	-1,	/* 86 */
	YYLNK,	5,
	0,	20033,	/* 87 */
	YYLNK,	47,
	0,	0
};
typedef	struct {
	short	old;
	short	new;
} YYGOTO;
YYGOTO	yyg1[] = {
	1,	44,
	30,	88,
	32,	89,
	34,	90,
	40,	95,
	42,	96,
	68,	140,
	70,	142,
	72,	144,
	74,	146,
	76,	148,
	78,	150,
	82,	152,
	84,	154,
	86,	156,
	98,	159,
	100,	161,
	102,	163,
	104,	165,
	106,	167,
	108,	169,
	110,	171,
	112,	173,
	114,	175,
	116,	177,
	118,	178,
	120,	180,
	122,	182,
	124,	184,
	126,	187,
	128,	189,
	130,	191,
	132,	193,
	134,	195,
	136,	197,
	138,	199,
	201,	203,
	-1,	-1
};
YYGOTO	yyg2[] = {
	0,	1,
	-1,	-1
};
YYGOTO	*yyg[] = {
	0,
	yyg2,
	yyg2,
	yyg2,
	yyg2,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
	yyg1,
};
short	yylen[] = {
	1,
	0,
	2,
	3,
	3,
	3,
	2,
	2,
	2,
	2,
	2,
	2,
	2,
	2,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	5,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	3,
	1,
	1,
	3,
};
#include "yaccpar.c"
#line 226 "expr.y"


char* atoh(char* s, double* r)
{
	register short c;

	*r = (double)0;
	while (isxdigit(c = *s)) {
		*r *= 0x10;
		*r += isdigit(c) ? c - '0' : tolower(c) - 'a' + 0xa;
		++s;
	}
	return s;
}

#define plural(c,fc,sc,id)		\
	if ((c) == (fc)) {	\
		if (((c) = *eval_s++) == (sc))	\
			return id;	\
		else {	\
			--eval_s;	\
			return fc;	\
		}	\
	}

int	yylex(void)
{
	if (eval_end)
		//return YYEOF;
		return EOF;
	else {
		int	c;
		do {
			c = *eval_s++;
			if (isalpha(c) || c == '_') {
				static char buff[1024];		// ꂾƂƂΑv낤
				char *p = buff;
				yylval.name = buff;
				eval_s--;
				do {
					*p++ = *eval_s++;
				} while (isalnum(*eval_s) || *eval_s == '_');
				*p = '\0';
				yylval.name = xstrdup(buff);
				return VARIABLE;
			}else if (isdigit(c)) {
				if (c == '0' && tolower(*eval_s) == 'x') {
					++eval_s;
					/* skimp.... */
					eval_s = atoh(eval_s, &yylval.value);
				}else{
					yylval.value = atof(--eval_s);
				}

				{
					BOOL point = FALSE;
					BOOL exp = FALSE;
					#define FORM_ERR	"_̃tH[}bgႢ܂"
					for (; isdigit(*eval_s); ++eval_s) {
						if (eval_s[1] == '.') {
							++eval_s;
							if (point || exp) {
								yyerror(FORM_ERR);
							}else{
								point = TRUE;
							}
						}else if (tolower(eval_s[1]) == 'e') {
							eval_s += 2;
							if (exp) {
								yyerror(FORM_ERR);
							}else{
								exp = TRUE;
								if (*eval_s != '+' && *eval_s != '-') {
									yyerror(FORM_ERR);
								}
							}
						}
					}
				}
				return Y_NUMBER;
			}
			else plural(c, '*', '*', POWER)
			else plural(c, '<', '<', SHL)
			else plural(c, '>', '>', SHR)
			else plural(c, '+', '+', INC)
			else plural(c, '-', '-', DEC)
			else plural(c, '<', '=', LEQ)
			else plural(c, '>', '=', GEQ)
			else plural(c, '|', '|', OR)
			else plural(c, '&', '&', AND)
			else plural(c, '=', '=', IDN)
			else plural(c, '!', '=', DIF)
			else plural(c, '+', '=', PLEQ)
			else plural(c, '-', '=', MIEQ)
			else plural(c, '*', '=', MULEQ)
			else plural(c, '/', '=', DIVEQ)
			else plural(c, '%', '=', MODEQ)
			else plural(c, '&', '=', ANDEQ)
			else plural(c, '^', '=', XOREQ)
			else plural(c, '|', '=', OREQ)
			else if (c == '\0') {
				eval_end = 1;
				return EOL;
			}
		} while (isspace(c)) ;
		return c;
	}
}

double evaluate(char *s)
{
	extern int yyparse();

	acc = (double)0;
	var_assigned = FALSE;
	no_err = TRUE;
	if (s == NULL)
		return 0;
	else {
		eval_end = 0;
		eval_s = s;
		yyparse();
		return acc = eval_val;
	}
}
