// clipbd.h --- Nbv{[h̃wp
//
// Copyright (C) 1996 by Hirofumi YAMAMOTO, Hiro Software Factory. All rights reserved.
//
// $Id: clipbd.h 1.2 1996/05/26 17:06:04 hirofumi Rel $

#ifndef CLIPBD_H
#define CLIPBD_H

class Clipboard {
protected:
	BOOL m_opened;
	CWnd* m_wnd;
public:
	Clipboard(CWnd* wnd, BOOL doOpen = TRUE)
		: m_opened(FALSE), m_wnd(wnd)
	{
		if (doOpen)
			Open();
	}
	BOOL Open()
	{
		if (m_opened)
			return TRUE;
		BOOL r = ::OpenClipboard(m_wnd->GetSafeHwnd());
		if (r)
			m_opened = TRUE;
		return r;
	}
	BOOL Close()
	{
		ASSERT(m_opened);
		m_opened = FALSE;
		return CloseClipboard();
	}
	~Clipboard()
	{
		if (m_opened)
			::CloseClipboard();
	}
	static BOOL IsFormatAvailable(UINT format)
	{
		return ::IsClipboardFormatAvailable(format);
	}

	HANDLE SetData(UINT format, HANDLE hData)
	{
		return ::SetClipboardData(format, hData);
	}
	HANDLE SetData(UINT format, const char* s)
	{
		HGLOBAL hmem = GlobalAlloc(GHND | GMEM_DDESHARE, strlen(s) + 1);
		if (hmem == NULL)
			return NULL;
		char* p = (char*)GlobalLock(hmem);
		strcpy(p, s);
		GlobalUnlock(p);
		return SetData(format, hmem);
	}
	HANDLE GetData(UINT format)
	{
		return ::GetClipboardData(format);
	}
	BOOL Empty()
	{
		return ::EmptyClipboard();
	}
};

#endif
