// defExpr.cpp : Cve[V t@C
// ̒`
//
// Copyright (C) 1996 by Hirofumi YAMAMOTO, Hiro Software Factory. All rights reserved.
//

#include "stdafx.h"
#include "ecalc.h"
#include "defExpr.h"
#include "var.h"
#include "expr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static char rcs_id[] =
	"$Id: defExpr.cpp 1.4 1996/05/26 17:03:12 hirofumi Rel $";

/////////////////////////////////////////////////////////////////////////////
// DefineExpr _CAO


DefineExpr::DefineExpr(Variables* vars, CWnd* pParent /*=NULL*/)
	: CDialog(DefineExpr::IDD, pParent), m_variables(vars),
	  m_spFont(NULL)
{
	//{{AFX_DATA_INIT(DefineExpr)
	m_varName = _T("");
	m_expr = _T("");
	//}}AFX_DATA_INIT
}


void DefineExpr::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DefineExpr)
	DDX_Control(pDX, IDC_VARNAME, m_varNameCtrl);
	DDX_CBString(pDX, IDC_VARNAME, m_varName);
	DDX_Text(pDX, IDC_EXPR, m_expr);
	//}}AFX_DATA_MAP
	if (pDX->m_bSaveAndValidate) {
		// ϐ̃`FbN
		pDX->PrepareEditCtrl(IDC_VARNAME);
		if (m_varName.IsEmpty()) {
			AfxMessageBox(IDP_MUST_SPECIFY_VARNAME);
			pDX->Fail();
		}
		Variable* v = (*m_variables)[m_varName];
		if (v && v->IsReserved()) {
			AfxMessageBox(IDP_CANT_DEFINE_TO_RESERVED);
			pDX->Fail();
		}
		for (int i = 0; i < m_varName.GetLength(); ++i) {
			if ((i == 0 && !isalpha(m_varName[i]))
			  || !isalnum(m_varName[i])) {
				AfxMessageBox(IDP_ILLEGAL_VARNAME);
				pDX->Fail();
			}
		}
		// `FbN
		pDX->PrepareEditCtrl(IDC_EXPR);
		// TCNbN`FbN
		if (!g_variables.CheckCyclic(m_varName, m_expr)) {
			pDX->Fail();
		}
	}
}


BEGIN_MESSAGE_MAP(DefineExpr, CDialog)
	//{{AFX_MSG_MAP(DefineExpr)
	ON_BN_CLICKED(IDC_REF_VAR, OnRefVar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DefineExpr bZ[W nh

BOOL DefineExpr::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	BOOL focused = FALSE;
	ASSERT(m_variables);
	POSITION pos = m_variables->GetStartPosition();
	while (pos) {
		Variable* v = NULL;
		CString name;
		m_variables->GetNextAssoc(pos, name, v);
		ASSERT(v);
		if (!v->IsReserved())
			m_varNameCtrl.AddString(name);
	}
	
	if (!m_name.IsEmpty()) {
		// ̎ҏW
		m_varNameCtrl.SetWindowText(m_name);
		VERIFY( m_varNameCtrl.SetEditSel(-1, -1) );
		CWnd* expr = GetDlgItem(IDC_EXPR);
		ASSERT(expr);
		//expr->SetFocus();
		//GotoDlgCtrl(expr);
		//focused = TRUE;
		m_varNameCtrl.EnableWindow(FALSE);
		GetDlgItem(IDC_REF_VAR)->ShowWindow(SW_HIDE);
		Variable* v = (*m_variables)[m_name];
		ASSERT(v);
		expr->SetWindowText(v->GetExpression());
	}

	if (m_spFont) {
		GetDlgItem(IDC_VARNAME)->SetFont(m_spFont);
		GetDlgItem(IDC_EXPR)->SetFont(m_spFont);
	}

	return !focused;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void DefineExpr::OnRefVar() 
{
	// ϐ玮QƂ
	CString name;
	m_varNameCtrl.GetWindowText(name);
	if (name.IsEmpty()) {
		::MessageBeep(IDOK);
		return;
	}
	Variable* v = (*m_variables)[name];
	if (!v) {
		::MessageBeep(IDOK);
		return;
	}
	GetDlgItem(IDC_EXPR)->SetWindowText(v->GetExpression());
}
