// ecalcDlg.cpp : Cve[V t@C
//
// Copyright (C) 1996 by Hirofumi YAMAMOTO, Hiro Software Factory. All rights reserved.
//

#include "stdafx.h"
#include "ecalc.h"
#include "ecalcDlg.h"
#include "defExpr.h"

#include "clipbd.h"

#include "expr.h"

// IsKindOf(), DYNAMIC_DOWNCAST, STATIC_DOWNCASTs߂ɕKv
IMPLEMENT_DYNAMIC(CEcalcDlg, CDialog)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static char rcs_id[] =
	"$Id: ecalcDlg.cpp 1.10 1996/05/26 17:55:28 hirofumi Rel hirofumi $";


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐𐶐I[o[Ch܂
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// p[VXegEBhE wp

static TCHAR pwSection[] = _T("Settings");
static TCHAR pwWindowPos[] = _T("WindowPos");
static TCHAR pwFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(pwSection, pwWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = _stscanf(strBuffer, pwFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	TCHAR buf[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(buf, pwFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(pwSection, pwWindowPos, buf);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEcalcDlg _CAO

CEcalcDlg::CEcalcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEcalcDlg::IDD, pParent),
	  m_dispFormat(DF_DEC), m_valueFormat(m_dispFormat), m_closing(FALSE),
	  m_minSize(0, 0), m_spacing(0)
{
	//{{AFX_DATA_INIT(CEcalcDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// BEGIN ADDING
	// X[ACRǂݍ
	m_smallIcon = (HICON)::LoadImage(AfxGetApp()->m_hInstance, 
		MAKEINTRESOURCE(IDR_MAINFRAME),
		IMAGE_ICON, 16, 16, 0);
	ASSERT(m_smallIcon);


	// C[WXg̍쐬
	VERIFY( m_imageList.Create(IDB_IMAGELIST, 8, 0, RGB(255, 0, 0)) );
	// END ADDING
}

CEcalcDlg::~CEcalcDlg()
{
}

void CEcalcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEcalcDlg)
	DDX_Control(pDX, IDC_VAR_LIST, m_varList);
	DDX_Control(pDX, IDC_INPUT, m_input);
	DDX_Control(pDX, IDC_HISTORY, m_history);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEcalcDlg, CDialog)
	//{{AFX_MSG_MAP(CEcalcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LP, OnLp)
	ON_BN_CLICKED(IDC_MUL, OnMul)
	ON_BN_CLICKED(IDC_PLUS, OnPlus)
	ON_BN_CLICKED(IDC_RP, OnRp)
	ON_BN_CLICKED(IDC_SUB, OnSub)
	ON_BN_CLICKED(IDC_DOT, OnDot)
	ON_BN_CLICKED(IDC_DIV, OnDiv)
	ON_BN_CLICKED(IDC_CLR, OnClr)
	ON_LBN_DBLCLK(IDC_HISTORY, OnDblclkHistory)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_VAR_LIST, OnColumnclickVarList)
	ON_NOTIFY(NM_DBLCLK, IDC_VAR_LIST, OnDblclkVarList)
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_SHL, OnShl)
	ON_BN_CLICKED(IDC_SHR, OnShr)
	ON_BN_CLICKED(IDC_POWER, OnPower)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_EXPR, OnExpr)
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_BUTTON0, IDC_BUTTON9, OnNumButton)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// ϐ 

void CEcalcDlg::RefreshVariableDisplay()
{
	LPCTSTR title = _T("");
	UINT format = LVCFMT_RIGHT;
	switch (m_dispFormat) {
	case DF_DEC:
		title = _T("li10i)");
		break;
	case DF_BIN:
		title = _T("li2ij");
		break;
	case DF_HEX:
		title = _T("li16ij");
		break;
	case DF_EXPR:
		title = _T("");
		format = LVCFMT_LEFT;
	}
#if 0	// MFC̒񋟂InsertColumn()g
	UINT width = 0;
	LV_COLUMN col;
	col.mask = LVCF_WIDTH;
	if (m_varList.GetColumn(F_VALUE, &col)) {
		width = col.cx;
	}
	else {
		CRect rc;
		m_varList.GetClientRect(rc);
		width = rc.Width() / 2;
	}
	m_varList.InsertColumn(F_VALUE, title, format, width, F_VALUE);
#else	// LV_COLUMNgăJCT[g
	LV_COLUMN col;
	col.mask = LVCF_WIDTH;
	if (!m_varList.GetColumn(F_VALUE, &col)) {
		CRect rc;
		m_varList.GetClientRect(rc);
		col.cx = rc.Width() * 2 / 3;
	}
	m_varList.DeleteColumn(F_VALUE);	// ̍ۃG[͋CɂȂ
	col.mask = LVCF_FMT | LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH;
	col.fmt = format;
	col.pszText = (LPTSTR)title;	// {Ȃ炱LXg͂낵ȂA
									// MFCłĂ̂ŗǂ̂ł傤
	col.iSubItem = F_VALUE;
	m_varList.InsertColumn(F_VALUE, &col);
#endif
	m_varList.DeleteAllItems();	// US
	
	// SĂ̕ϐ}
	// uϐꗗv̍ڂ͏Ƀ\[ĝŁA}鏇͖Ȃ
	POSITION pos = g_variables.GetStartPosition();
	while (pos) {
		CString name;
		Variable* v = NULL;
		g_variables.GetNextAssoc(pos, name, v);
		ASSERT(v);
		int nth = m_varList.InsertItem(F_VARNAME, name, v->GetListIndex());
		m_varList.SetItemText(nth, F_VALUE, v->GetValue(m_dispFormat));
	}
}


/////////////////////////////////////////////////////////////////////////////
// CEcalcDlg bZ[W nh

BOOL CEcalcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	
	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
#if 0
	SetIcon(m_hIcon, FALSE);		// ACRݒ
#else
	// MODIFIED: Windows 95pX[ACRݒ肷
	SetIcon(m_smallIcon, FALSE);
#endif
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB

	// BEGIN ADDING
	// VXej[ő剻
	pSysMenu->DeleteMenu(SC_MAXIMIZE, MF_BYCOMMAND);
	// ŏTCYݒ
	CRect ini;
	GetWindowRect(ini);
	m_minSize = ini.Size();
	// ϐꗗƃt[̊Ԋu擾
	GetClientRect(ini);
	CRect rc;
	m_varList.GetWindowRect(rc);
	ScreenToClient(rc);
	m_spacing = ini.bottom - rc.bottom;

	// ϐꗗ̐ݒ
	m_varList.GetClientRect(&rc);
	m_varList.InsertColumn(F_VARNAME, _T("ϐ"), LVCFMT_LEFT, rc.Width() / 3 - ::GetSystemMetrics(SM_CXVSCROLL), F_VARNAME);
	m_varList.SetImageList(&m_imageList, LVSIL_SMALL);

	RefreshVariableDisplay();

	// Windows95C^tF[XłȂꍇɂ́AI{^\
	if (LOBYTE(::GetVersion()) < 0x04) {	// W[ԍ
		GetDlgItem(IDC_EXIT)->ShowWindow(SW_SHOWNA);
		GetDlgItem(IDC_EXIT)->EnableWindow();
	}
	// tHgݒ
	CFont* ff = GetFont();
	LOGFONT lf;
	VERIFY( ff->GetLogFont(&lf) );
	//strcpy(lf.lfFaceName, _T("Arial Black"));
	strcpy(lf.lfFaceName, _T("Arial"));
	lf.lfCharSet = ANSI_CHARSET;
	lf.lfWeight = FW_EXTRABOLD;
	lf.lfPitchAndFamily = DEFAULT_PITCH | FF_DONTCARE;
	VERIFY( m_spFont.CreateFontIndirect(&lf) );
	m_input.SetFont(&m_spFont);
	for (UINT i = IDC_BUTTON0; i <= IDC_BUTTON9; ++i) {
		SetDlgItemFont(i, &m_spFont);
	}
	SetDlgItemFont(IDC_DIV, &m_spFont);
	//SetDlgItemFont(IDC_MUL, &m_spFont);	// tۂȂĂ܂
	SetDlgItemFont(IDC_SUB, &m_spFont);
	SetDlgItemFont(IDC_PLUS, &m_spFont);
	SetDlgItemFont(IDC_DOT, &m_spFont);

	// oĂʒuƑ傫XgA
	WINDOWPLACEMENT wp;
	if (ReadWindowPlacement(&wp)) {
		SetWindowPlacement(&wp);
	}
	// END ADDING
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CEcalcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else {
		if ((nID & 0xfff0) == SC_CLOSE) {
			// VXeR}hɂN[YƂtO𗧂Ă
			m_closing = TRUE;
		}
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CEcalcDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CEcalcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Windows NT 3.51̏ꍇ̒Eo(Exit{^)
void CEcalcDlg::OnExit() 
{
	m_closing = TRUE;
	OnCancel();
}

void CEcalcDlg::OnCancel() 
{
	if (!m_closing) {
		// OnCancel()́AESCL[łĂ΂
		// VXej[̃N[YłȂΖ
		TRACE0(_T("CRegtestDlg::OnCancel() -- ignoreed.\n"));
		return;
	}

	// EBhEʒuۑ
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if (GetWindowPlacement(&wp))
		WriteWindowPlacement(&wp);

	CDialog::OnCancel();
}

void CEcalcDlg::OnOK() 
{
	// ^[L[ƂĂBZs
	CString input;
	m_input.GetWindowText(input);
	if (input.IsEmpty()) {
		// ̎͂ȂɂȂ
		MessageBeep(IDOK);
		return;
	}
	CString work = input;
	char* p = work.GetBuffer(0);
	double* result = evaluate(p);
	work.ReleaseBuffer();
	if (result == NULL)	// G[
		return;

	// _CAO֔f
	CString buf;
	if (m_history.GetCount() > 0)
		m_history.GetText(0, buf);
	if (buf != input) {
		m_history.InsertString(0, input);	// ͂ꂽqXgɒǉ
		m_history.SetCurSel(0);
	}
	// ʂ\ϐ֑
	Variable* v = g_variables[resultVarName];
	ASSERT(v);
	v->SetValue(*result);
	g_variables.Calculate();
	RefreshVariableDisplay();

	// ̓GfBbgRg[։Zʂݒ肷
	input = v->GetValue();
	m_input.SetWindowText(input);
	m_input.SetSel(0, -1);

#if 0	// ̏͌Ă΂Ȃ
	CDialog::OnOK();
#endif
}

void CEcalcDlg::SetDlgItemFont(UINT id, CFont* font)
{
	CWnd* wnd = GetDlgItem(id);
	ASSERT(wnd);
	wnd->SetFont(font);
}

// {^܂Ƃ߂Ĉ
void CEcalcDlg::OnNumButton(UINT id)
{
	ASSERT(id >= IDC_BUTTON0 && id <= IDC_BUTTON9);
	id -= IDC_BUTTON0;	// id0`9
	CString buf;
	buf.Format(_T("%d"), id);
	m_input.ReplaceSel(buf);
}

void CEcalcDlg::OnLp() 
{
	m_input.ReplaceSel(_T("("));
}

void CEcalcDlg::OnMul() 
{
	m_input.ReplaceSel(_T("*"));
}

void CEcalcDlg::OnPlus() 
{
	m_input.ReplaceSel(_T("+"));
}

void CEcalcDlg::OnRp() 
{
	m_input.ReplaceSel(_T(")"));
}

void CEcalcDlg::OnSub() 
{
	m_input.ReplaceSel(_T("-"));
}

void CEcalcDlg::OnDot() 
{
	m_input.ReplaceSel(_T("."));
}

void CEcalcDlg::OnDiv()
{
	m_input.ReplaceSel(_T("/"));
}

void CEcalcDlg::OnPower() 
{
	m_input.ReplaceSel(_T("**"));
}

void CEcalcDlg::OnShl() 
{
	m_input.ReplaceSel(_T("<<"));
}

void CEcalcDlg::OnShr() 
{
	m_input.ReplaceSel(_T(">>"));
}

void CEcalcDlg::OnClr()
{
	m_input.SetWindowText(_T(""));
}

// ̃_uNbN
void CEcalcDlg::OnDblclkHistory() 
{
	int sel = m_history.GetCurSel();
	if (sel < 0)	// fail safe
		return;
	// ̓GfBbgRg[֎Rs[
	CString buf;
	m_history.GetText(sel, buf);
	m_input.SetWindowText(buf);
	// ̓GfBbgRg[փtH[JXڂASẴeLXgIԂɂ
	m_input.SetFocus();
	int n = m_input.GetWindowTextLength();
	m_input.SetSel(n, n);
}

// ϐꗗ̃wb_̃NbN
void CEcalcDlg::OnColumnclickVarList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	if (pNMListView->iSubItem == F_VALUE) {
		// ulvNbNꂽ̂ŁA\tH[}bg؂ւ
		switch (m_dispFormat) {
		case DF_DEC:	m_dispFormat = DF_HEX;	break;
		case DF_HEX:	m_dispFormat = DF_BIN;	break;
		case DF_BIN:	m_dispFormat = DF_DEC;	break;
		case DF_EXPR:	m_dispFormat = m_valueFormat;	break;
		}
		m_valueFormat = m_dispFormat;
		RefreshVariableDisplay();
	}
	else if (pNMListView->iSubItem == F_VARNAME) {
		// uϐvNbNꂽꍇɂ́A\
		if (m_valueFormat == m_dispFormat)
			m_dispFormat = DF_EXPR;
		else
			m_dispFormat = m_valueFormat;
		RefreshVariableDisplay();
	}
	
	*pResult = 0;
}

void CEcalcDlg::InsertVar(int n)
{
	ASSERT(n >= 0);
	CString name = m_varList.GetItemText(n, 0);
	// ͂̃eLXgRg[֕ϐRs[
	m_input.ReplaceSel(name + _T(" "));
}

// ϐꗗɑ΂_uNbN
void CEcalcDlg::OnDblclkVarList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (pNMHDR->hwndFrom != m_varList.GetSafeHwnd())
		return;
#if 0
	// JOȊOŉĂꍇ͂
	CPoint pt = GetCurrentMessage()->pt;	// _uNbNW擾
	// ǂ̃ACȅŃ_uNbNꂽ肷
	m_varList.ScreenToClient(&pt);
	int sel = m_varList.GetItemFromPoint(pt);
#else
	// JOł̂ݔꍇ͂
	int sel = m_varList.GetCurSel();
#endif
	if (sel >= 0) {
		InsertVar(sel);
	}
	*pResult = 0;
}

// ϐ폜FńAϐꗗł̃CfNX
// n < 0Ȃ\ϐSĂ̕ϐ폜
void CEcalcDlg::DeleteVar(int n)
{
	if (n >= 0) {
		// ЂƂ폜
		CString name = m_varList.GetItemText(n, 0);

		Variable* v = g_variables[name];
		ASSERT(v);
		if (v->IsReserved()) {
			// \ϐ͍폜łȂ
			AfxMessageBox(IDP_CANT_DELETE_RESULT_VAR, MB_ICONINFORMATION | MB_OK);
			return;
		}
		VERIFY( g_variables.RemoveKey(name) );
		delete v;
		m_varList.DeleteItem(n);
	}
	else {
		// Sč폜
		m_varList.DeleteAllItems();
		POSITION pos = g_variables.GetStartPosition();
		while (pos) {
			CString name;
			Variable* v = NULL;
			g_variables.GetNextAssoc(pos, name, v);
			if (!v->IsReserved()) {
				delete v;
				g_variables.RemoveKey(name);
			}
		}
		RefreshVariableDisplay();
	}
}

void CEcalcDlg::CopyVarValue(int sel)
{
	ASSERT(sel >= 0);
	CString name = m_varList.GetItemText(sel, 0);
	Variable* v = NULL;
	VERIFY( g_variables.Lookup(name, v) );
	ASSERT(v != NULL);
	CString value = v->GetValue();
	Clipboard clipbd(this);
	if (!clipbd.Open())
		return;
	clipbd.SetData(CF_TEXT, value);
}

// ReNXgj[
void CEcalcDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	if (pWnd->GetSafeHwnd() == m_varList.GetSafeHwnd()) {
		// ϐEBhEŃReLXgZVeBuj[Ă΂ꂽ
		int sel = m_varList.GetCurSel();
		UINT menuId = IDM_VAR_POPUP;
		if (sel < 0)
			menuId = IDM_VAR_POPUP_NOSEL;
		menuId += m_dispFormat;
		CMenu menu;
		menu.LoadMenu(menuId);
		if (point.x < 0) {
			// Shift + F10
			if (sel >= 0) {
				m_varList.GetItemPosition(sel, &point);
				m_varList.ClientToScreen(&point);
				point += CSize(10, 0);
			}
			else {
				CRect rc;
				m_varList.GetWindowRect(rc);
				point = rc.TopLeft() + CSize(10, 5);
			}
		}
		int id = menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_LEFTALIGN | TPM_RETURNCMD,
			point.x, point.y, pWnd);
		switch (id) {
		case ID_DELETE_VAR:
			ASSERT(sel >= 0);
			DeleteVar(sel);
			break;
		case ID_INSERT_VAR:
			ASSERT(sel >= 0);
			InsertVar(sel);
			break;
		case ID_CLEAR_ALL_VAR:
			DeleteVar(-1);
			break;
		case ID_COPY_VALUE:
			CopyVarValue(sel);
			break;
		case ID_NEW_EXPR:
			OnExpr();
			break;
		case ID_EDIT_EXPR:
			{
				CString nn = m_varList.GetItemText(sel, 0);
				EditExpr(nn);
			}
			break;
		case ID_DISP_DEC:
		case ID_DISP_BIN:
		case ID_DISP_HEX:
			m_valueFormat = DisplayFormat(id - ID_DISP_DEC);
			// through down
		case ID_DISP_EXPR:
			m_dispFormat = DisplayFormat(id - ID_DISP_DEC);
			RefreshVariableDisplay();
			break;
		}
	}
	else if (pWnd->GetSafeHwnd() == m_history.GetSafeHwnd()) {
		int sel = m_history.GetCurSel();
		UINT menuId = IDM_HISTORY_POPUP;
		if (sel < 0)
			menuId = IDM_HISTORY_POPUP_NOSEL;
		CMenu menu;
		if (point.x < 0) {
			// Shift + F10
			if (sel >= 0) {
				CRect rc;
				m_history.GetItemRect(sel, rc);
				m_history.ClientToScreen(rc);
				point = rc.TopLeft() + CSize(10, 0);
			}
			else {
				CRect rc;
				m_history.GetWindowRect(rc);
				point = rc.TopLeft() + CSize(10, 5);
			}
		}
		menu.LoadMenu(menuId);
		int id = menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_LEFTALIGN | TPM_RETURNCMD,
			point.x, point.y, pWnd);
		switch (id) {
		case ID_INSERT_EXPR:
			ASSERT(sel >= 0);
			OnDblclkHistory();
			break;
		case ID_CLEAR_ALL_HISTORY:
			m_history.ResetContent();
			break;
		}
	}
	else {
		CDialog::OnContextMenu(pWnd, point);
	}
}

void CEcalcDlg::EditExpr(LPCTSTR name/* = NULL */)
{
	DefineExpr dlg(&g_variables);
	if (name)
		dlg.m_name = name;
	dlg.m_spFont = &m_spFont;
	
	if (dlg.DoModal() != IDOK)
		return;
	Variable* v = g_variables[dlg.m_varName];
	if (v == NULL)
		v = new Variable;
	v->SetExpression(dlg.m_expr);
	g_variables.SetAt(dlg.m_varName, v);
	g_variables.CreateTree();
	g_variables.Calculate();
	RefreshVariableDisplay();
}

void CEcalcDlg::OnExpr() 
{
	EditExpr();
}

void CEcalcDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if (m_minSize.cx) {
		lpMMI->ptMinTrackSize.x = m_minSize.cx;
		lpMMI->ptMinTrackSize.y = m_minSize.cy;
		lpMMI->ptMaxTrackSize.x = m_minSize.cx;
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CEcalcDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (nType == SIZE_RESTORED && m_spacing) {	
		ASSERT(m_varList.GetSafeHwnd());
		CRect rc;
		m_varList.GetWindowRect(rc);
		ScreenToClient(rc);
		rc.bottom = cy - m_spacing;
		m_varList.MoveWindow(rc);
	}
}
