// var.h --- ϐ
//
// Copyright (C) 1996 by Hirofumi YAMAMOTO, Hiro Software Factory. All rights reserved.
//
// $Id: var.h 1.5 1996/05/26 17:55:28 hirofumi Rel hirofumi $
//

#ifndef VAR_H
#define VAR_H

class CStringMap : public CTypedPtrMap<CMapStringToPtr, CString, void*> {
public:
	BOOL operator[](LPCTSTR);
	void Add(LPCTSTR);
};

typedef enum { DF_DEC = 0, DF_BIN, DF_HEX, DF_EXPR } DisplayFormat;

class Variable {
public:
	Variable(BOOL isReserved = FALSE);
	virtual ~Variable();
public:
	BOOL IsReserved();
	virtual int GetListIndex();
	CString GetValue(int format = DF_DEC);
	virtual void SetValue(double value);
	operator double();
public:
	virtual void SetExpression(LPCTSTR);	// ̒`
	virtual const CString& GetExpression();	// ̂߁c

	// ̌vZуTCNbN`FbN
	double Calculate();
	void InitCyclicCheck();
	void ClearCalculatedFlag() { m_calculated = FALSE; }
	void ClearReferenceFlag() { m_referred = FALSE; }
	BOOL IsReferred() { return m_referred; }
	void SetReferred() { m_referred = TRUE; }
	BOOL IsCalculated() { return m_type == T_VALUE || m_calculated; }
	void SetCalculated() { m_calculated = TRUE; }
protected:
	void DumpBin(CString&, __int64, int col = 1);
protected:
	double m_value;
	CString m_expr;
	BOOL m_isReserved;
	enum { T_VALUE, T_EXPR } m_type;

	BOOL m_referred;
	BOOL m_calculated;
	CStringMap m_lookup;
	friend class Variables;
};

class Constant : public Variable {
public:
	Constant(double);
public:
	virtual void SetValue(double);
	virtual int GetListIndex();
protected:
	virtual void SetExpression(LPCSTR) { ASSERT(0); }
	virtual const CString& GetExpression() { static CString afo; return afo; }
};

class Variables : public CTypedPtrMap<CMapStringToPtr, CString, Variable*> {
public:
	Variables();
	virtual ~Variables();
	Variable* operator[](LPCTSTR);

	double GetVariable(LPCTSTR name);
	void SetVariable(LPCTSTR name, double value);
	char* AllocWorkStr(LPCTSTR);
	void DeleteAllWorkStr();

	void Calculate();
	void CreateTree();

	BOOL CheckCyclic(LPCTSTR name, LPCTSTR expr);
	void AddLookup(LPCTSTR name);

	// WXg
	void ReadReg();
	void WriteReg();
protected:
	void ClearAllReferenceFlags();

	void CalcEachVar(Variable*);
	void CheckEachVar(Variable*);

	BOOL m_checkingCyclic;
	Variable* m_currentChecking;
	CStringArray m_nameWork;
};

#define resultVarName _T("_result")

extern Variables g_variables;

#endif

