#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 8 "expr.y"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <math.h>

#include "expr.h"

#ifndef TRUE
#define TRUE	1
#define FALSE	0
#endif

double eval_val;
BOOL no_err;
BOOL var_assigned = FALSE;
double acc;

static char rcs_id[] =
	"$Id: expr.y 1.6 1996/05/26 17:55:28 hirofumi Rel hirofumi $";

static int eval_end;
/*static*/ char *eval_s = 0;

int yyerror(char *s);
int	yylex(void);

#if 1

#define mod(a,b)	(fmod((a),(b)))
#define and(a,b)	(double)((long)(a) & (long)(b))
#define or(a,b)		(double)((long)(a) | (long)(b))
#define xor(a,b)	(double)((long)(a) ^ (long)(b))
#define power(a,b)	(pow((a),(b)))
#define shl(a,b)	(double)((long)(a) << (long)(b))
#define shr(a,b)	(double)((long)(a) >> (long)(b))
#define not(a)		(double)(~(long)(a))

#else	/* RTYPE != double */

#define mod(a,b)	((a) % (b))
#define and(a,b)	((a) & (b))
#define or(a,b)		((a) | (b))
#define xor(a,b)	((a) ^ (b))
#define shl(a,b)	((a) << (b))
#define shr(a,b)	((a) >> (b))
#define not(a)		(~(a))

double power(double a, double b)
{
	/* skimp.... */
	double l = a, r;
	
	if (b < 0) {
		return 0;
	}else if (b == 0) {
		return 1;
	}else if (a == 0) {
		if (b >= 0) {
			return 0;
		}
		yyerror("pow ?");
	}else{
		for (r = 1; r < b; ++r) {
			l *= a;
		}
	}
	return l;
}

#endif	/* end of double != double */

double preinc(char* name)
{
	return assign_variable(name, eval_variable(name) + 1);
}

double predec(char* name)
{
	return assign_variable(name, eval_variable(name) - 1);
}

double postinc(char* name)
{
	return acc = assign_variable(name, eval_variable(name) + 1) - 1;
}

double postdec(char* name)
{
	return acc = assign_variable(name, eval_variable(name) - 1) + 1;
}

int yyerror(char *s)
{
	no_err = FALSE;
	/*fprintf(stderr, "%s\n", s);*/
	HandleError(s);
	return -1;
}

#line 111 "expr.y"
typedef union {
	char* name;
	double value;
} YYSTYPE;
#line 113 "y.tab.c"
#define VARIABLE 257
#define Y_NUMBER 258
#define EOL 259
#define PLEQ 260
#define MIEQ 261
#define MULEQ 262
#define DIVEQ 263
#define MODEQ 264
#define INC 265
#define DEC 266
#define POWER 267
#define SHL 268
#define SHR 269
#define ANDEQ 270
#define XOREQ 271
#define OREQ 272
#define OR 273
#define AND 274
#define IDN 275
#define DIF 276
#define LEQ 277
#define GEQ 278
#define UNARY 279
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    2,    3,    3,    3,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    5,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    1,    1,    3,
};
short yydefred[] = {                                      1,
    0,    0,    0,   44,    2,    0,    0,    0,    0,    0,
    0,    0,    0,    4,    0,    0,    0,    0,    0,    0,
   10,   11,    0,    0,    0,    7,    6,    0,    8,    9,
   12,   13,    3,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   24,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
short yydgoto[] = {                                       1,
   13,
};
short yysindex[] = {                                      0,
   65, -257,  543,    0,    0,  593,  593,  593, -254, -248,
  593,  593,   29,    0,  593,  593,  593,  593,  593,  593,
    0,    0,  593,  593,  593,    0,    0,   41,    0,    0,
    0,    0,    0,  593,  593,  593,  593,  593,  593,  593,
  593,  593,  593,  593,  593,  593,  593,  593,  593,  593,
  593,  593,  593,  593,  319,  319,  319,  319,  319,  319,
  319,  319,  319,    0,   14,   14, -238, -238, -238,  217,
  624,  565,  565,    0, -252, -252,  319,   69,  354,  380,
  565,  565,  565,  565,  597,  593,  319,
};
short yyrindex[] = {                                      0,
    0,    0,  -37,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -30,  -17,   36,  106,  116,  129,
  169,  413,  490,    0,  406,  417,   96,  134,  161,  291,
  452,  342,  458,    0,  -25,    2,  540,    0,  125,  104,
  464,  484,  494,  517,  429,    0,  541,
};
short yygindex[] = {                                      0,
  861,
};
#define YYTABLESIZE 947
short yytable[] = {                                      43,
   43,   14,   29,   43,   43,   43,   43,   43,   30,   43,
   34,   22,   22,   34,   43,   22,   22,   22,   22,   22,
   43,   22,   43,   35,   43,   43,   35,   34,   43,   44,
   45,    0,   22,    0,   22,    0,   22,   22,   23,   23,
   35,    0,   23,   23,   23,   23,   23,    0,   23,    0,
   38,    0,    0,    0,    0,   36,   43,    0,    0,   23,
   37,   23,    0,   23,   23,   38,   39,    0,   22,    0,
   36,   34,   46,   35,    0,   37,   36,   38,   39,   36,
    0,   64,   36,   34,   46,   35,   43,   37,   41,    0,
   42,   47,    0,   36,    0,   23,    0,   11,   22,    0,
   41,    0,   42,   47,    8,   38,   39,    6,    0,    7,
   36,   34,   46,   35,    0,   37,    0,    0,    0,    0,
    0,    0,   54,    0,    0,   23,   86,    0,   41,    0,
   42,   47,   16,   16,   54,    0,   16,   16,   16,   16,
   16,    0,   16,    0,   25,    0,   37,   25,    0,   37,
    0,    0,   40,   16,    0,   16,   38,   16,   16,   38,
    0,   25,   54,   37,   40,   26,   25,    0,   26,   39,
   17,   17,   39,   38,   17,   17,   17,   17,   17,    0,
   17,    0,   26,    0,    0,    0,   39,   26,    0,   16,
   12,   17,   40,   17,    0,   17,   17,   18,   18,    0,
    0,   18,   18,   18,   18,   18,    0,   18,    0,   40,
    0,    0,   40,    0,    0,    0,    0,    0,   18,   16,
   18,   43,   18,   18,    0,    0,   40,   17,   34,   43,
   43,   43,    0,   22,    0,   43,   43,   43,   43,   43,
   43,   35,   22,   22,    0,    0,    0,   22,   22,   22,
   22,   22,   22,   38,   18,    0,    0,   17,   36,   34,
   23,   35,    0,   37,    0,    0,    0,    0,    0,   23,
   23,    0,    0,    0,   23,   23,   23,   23,   23,   23,
   43,   44,   45,    0,   18,    0,    0,   33,    0,    0,
    0,    0,    0,    0,   36,   43,   44,   45,    0,    0,
    0,   48,   49,   50,   51,   52,   53,   43,   44,   45,
    0,    0,    0,   48,   49,   50,   51,   52,   53,    0,
    2,    3,    4,    5,    0,    0,    0,    0,   19,    9,
   10,   19,    0,    0,   19,   43,   44,   45,    0,    0,
    0,   48,   49,   50,   51,   52,   53,    0,   19,    0,
   19,    0,   19,   19,   16,   38,   39,    0,    0,    0,
   36,   34,   25,   35,   37,   37,    0,    0,   16,   16,
   16,   16,   16,   16,   38,    0,   25,   25,   41,    0,
   42,   47,   29,   26,   19,   29,    0,   39,    0,    0,
   38,   39,   17,    0,    0,   36,   34,   26,   35,   29,
   37,   29,    0,   29,   29,    0,   17,   17,   17,   17,
   17,   17,   54,   41,   19,   42,   38,   39,    0,   18,
    0,   36,   34,    0,   35,    0,   37,   40,    0,    0,
    0,    0,    0,   18,   18,   18,   18,   18,   18,   41,
    0,   42,   40,   14,    0,    0,   14,   54,   14,   14,
   14,    0,    0,   41,   15,    0,   41,   15,    0,   15,
   15,   15,    0,   14,    0,   14,    0,   14,   14,   21,
   41,    0,   21,   54,   15,    0,   15,   40,   15,   15,
    0,    0,    0,   43,   44,   45,   21,    0,   21,    0,
   21,   21,   20,    0,    0,   20,    0,    0,   31,   14,
    0,   31,    0,   40,   27,    0,    0,   27,    0,   20,
   15,   20,    0,   20,   20,   31,    0,   31,    0,   31,
   31,   27,   21,   27,   28,   27,   27,   28,    0,   14,
   42,    0,    0,   42,   30,    0,    0,   30,    0,    0,
   15,   28,    0,   28,    0,   28,   28,   42,    0,   19,
    0,   30,   21,   30,    0,   30,   30,   32,    0,    0,
   32,    0,    0,   19,   19,   19,   19,   19,   19,    0,
    0,    0,    0,    0,   32,   20,   32,    0,   32,   32,
    5,   33,    0,    5,   33,   43,   44,   45,    0,    0,
    0,   48,   49,   50,   51,   52,   53,    5,   33,    0,
   29,   38,   39,   15,    0,    0,   36,   34,    0,   35,
    0,   37,    0,    0,   29,   29,   29,   29,   29,   29,
   43,   44,   45,    0,    0,   11,    0,   49,   50,   51,
   52,   53,    8,   38,   39,    6,    0,    7,   36,   34,
    0,   35,    0,   37,    0,    0,   43,   44,   45,    0,
    0,    0,    0,    0,   50,   51,   52,   53,   54,    0,
   38,   39,    0,    0,   14,   36,   34,    0,   35,    0,
   37,   41,    0,    0,    0,   15,    0,    0,   14,   14,
   14,   14,   14,   14,    0,    0,    0,   21,   40,   15,
   15,   15,   15,   15,   15,    0,    0,    0,    0,    0,
    0,   21,   21,   21,   21,   21,   21,    0,    0,    0,
   20,    0,    0,    0,    0,    0,   31,   54,   12,    0,
    0,    0,   27,    0,   20,   20,   20,   20,   20,   20,
   31,   31,   31,   31,   31,   31,   27,   27,   27,   27,
   27,   27,   28,    0,    0,    0,    0,    0,   42,    0,
    0,    0,   30,    0,    0,    0,   28,   28,   28,   28,
   28,   28,    0,    0,    0,    0,   30,   30,   30,   30,
   30,   30,    0,    0,    0,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   32,
   32,   32,   32,   32,   32,    0,    0,    0,    5,   33,
    0,    0,   16,   17,   18,   19,   20,   21,   22,    0,
    0,    0,   23,   24,   25,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   43,   44,   45,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
    4,    0,    0,    0,    0,    0,    0,    9,   10,    0,
    0,    0,    0,   43,   44,   45,   26,   27,   28,    0,
    0,   31,   32,    0,    0,   55,   56,   57,   58,   59,
   60,    0,    0,   61,   62,   63,    0,    0,    0,    0,
   43,   44,   45,    0,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   87,
};
short yycheck[] = {                                      37,
   38,  259,  257,   41,   42,   43,   44,   45,  257,   47,
   41,   37,   38,   44,  267,   41,   42,   43,   44,   45,
   58,   47,   60,   41,   62,   63,   44,   58,  267,  268,
  269,   -1,   58,   -1,   60,   -1,   62,   63,   37,   38,
   58,   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,
   37,   -1,   -1,   -1,   -1,   42,   94,   -1,   -1,   58,
   47,   60,   -1,   62,   63,   37,   38,   -1,   94,   -1,
   42,   43,   44,   45,   -1,   47,   41,   37,   38,   44,
   -1,   41,   42,   43,   44,   45,  124,   47,   60,   -1,
   62,   63,   -1,   58,   -1,   94,   -1,   33,  124,   -1,
   60,   -1,   62,   63,   40,   37,   38,   43,   -1,   45,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,  124,   58,   -1,   60,   -1,
   62,   63,   37,   38,   94,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   41,   -1,   41,   44,   -1,   44,
   -1,   -1,  124,   58,   -1,   60,   41,   62,   63,   44,
   -1,   58,   94,   58,  124,   41,   63,   -1,   44,   41,
   37,   38,   44,   58,   41,   42,   43,   44,   45,   -1,
   47,   -1,   58,   -1,   -1,   -1,   58,   63,   -1,   94,
  126,   58,  124,   60,   -1,   62,   63,   37,   38,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   58,  124,
   60,  259,   62,   63,   -1,   -1,   58,   94,  259,  267,
  268,  269,   -1,  259,   -1,  273,  274,  275,  276,  277,
  278,  259,  268,  269,   -1,   -1,   -1,  273,  274,  275,
  276,  277,  278,   37,   94,   -1,   -1,  124,   42,   43,
  259,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  268,
  269,   -1,   -1,   -1,  273,  274,  275,  276,  277,  278,
  267,  268,  269,   -1,  124,   -1,   -1,  259,   -1,   -1,
   -1,   -1,   -1,   -1,  259,  267,  268,  269,   -1,   -1,
   -1,  273,  274,  275,  276,  277,  278,  267,  268,  269,
   -1,   -1,   -1,  273,  274,  275,  276,  277,  278,   -1,
  256,  257,  258,  259,   -1,   -1,   -1,   -1,   38,  265,
  266,   41,   -1,   -1,   44,  267,  268,  269,   -1,   -1,
   -1,  273,  274,  275,  276,  277,  278,   -1,   58,   -1,
   60,   -1,   62,   63,  259,   37,   38,   -1,   -1,   -1,
   42,   43,  259,   45,  259,   47,   -1,   -1,  273,  274,
  275,  276,  277,  278,  259,   -1,  273,  274,   60,   -1,
   62,   63,   41,  259,   94,   44,   -1,  259,   -1,   -1,
   37,   38,  259,   -1,   -1,   42,   43,  273,   45,   58,
   47,   60,   -1,   62,   63,   -1,  273,  274,  275,  276,
  277,  278,   94,   60,  124,   62,   37,   38,   -1,  259,
   -1,   42,   43,   -1,   45,   -1,   47,  259,   -1,   -1,
   -1,   -1,   -1,  273,  274,  275,  276,  277,  278,   60,
   -1,   62,  124,   38,   -1,   -1,   41,   94,   43,   44,
   45,   -1,   -1,   41,   38,   -1,   44,   41,   -1,   43,
   44,   45,   -1,   58,   -1,   60,   -1,   62,   63,   41,
   58,   -1,   44,   94,   58,   -1,   60,  124,   62,   63,
   -1,   -1,   -1,  267,  268,  269,   58,   -1,   60,   -1,
   62,   63,   41,   -1,   -1,   44,   -1,   -1,   41,   94,
   -1,   44,   -1,  124,   41,   -1,   -1,   44,   -1,   58,
   94,   60,   -1,   62,   63,   58,   -1,   60,   -1,   62,
   63,   58,   94,   60,   41,   62,   63,   44,   -1,  124,
   41,   -1,   -1,   44,   41,   -1,   -1,   44,   -1,   -1,
  124,   58,   -1,   60,   -1,   62,   63,   58,   -1,  259,
   -1,   58,  124,   60,   -1,   62,   63,   41,   -1,   -1,
   44,   -1,   -1,  273,  274,  275,  276,  277,  278,   -1,
   -1,   -1,   -1,   -1,   58,  124,   60,   -1,   62,   63,
   41,   41,   -1,   44,   44,  267,  268,  269,   -1,   -1,
   -1,  273,  274,  275,  276,  277,  278,   58,   58,   -1,
  259,   37,   38,   61,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,  273,  274,  275,  276,  277,  278,
  267,  268,  269,   -1,   -1,   33,   -1,  274,  275,  276,
  277,  278,   40,   37,   38,   43,   -1,   45,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,   -1,  275,  276,  277,  278,   94,   -1,
   37,   38,   -1,   -1,  259,   42,   43,   -1,   45,   -1,
   47,  259,   -1,   -1,   -1,  259,   -1,   -1,  273,  274,
  275,  276,  277,  278,   -1,   -1,   -1,  259,  124,  273,
  274,  275,  276,  277,  278,   -1,   -1,   -1,   -1,   -1,
   -1,  273,  274,  275,  276,  277,  278,   -1,   -1,   -1,
  259,   -1,   -1,   -1,   -1,   -1,  259,   94,  126,   -1,
   -1,   -1,  259,   -1,  273,  274,  275,  276,  277,  278,
  273,  274,  275,  276,  277,  278,  273,  274,  275,  276,
  277,  278,  259,   -1,   -1,   -1,   -1,   -1,  259,   -1,
   -1,   -1,  259,   -1,   -1,   -1,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,   -1,  273,  274,  275,  276,
  277,  278,   -1,   -1,   -1,  259,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  273,
  274,  275,  276,  277,  278,   -1,   -1,   -1,  259,  259,
   -1,   -1,  260,  261,  262,  263,  264,  265,  266,   -1,
   -1,   -1,  270,  271,  272,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
  258,   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,   -1,
   -1,   -1,   -1,  267,  268,  269,    6,    7,    8,   -1,
   -1,   11,   12,   -1,   -1,   15,   16,   17,   18,   19,
   20,   -1,   -1,   23,   24,   25,   -1,   -1,   -1,   -1,
  267,  268,  269,   -1,   34,   35,   36,   37,   38,   39,
   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
   50,   51,   52,   53,   54,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   86,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 279
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,
0,0,0,0,0,"':'",0,"'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'|'",0,"'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VARIABLE","Y_NUMBER","EOL","PLEQ",
"MIEQ","MULEQ","DIVEQ","MODEQ","INC","DEC","POWER","SHL","SHR","ANDEQ","XOREQ",
"OREQ","OR","AND","IDN","DIF","LEQ","GEQ","UNARY",
};
char *yyrule[] = {
"$accept : line",
"line :",
"line : line EOL",
"line : line expr EOL",
"line : line error EOL",
"expr : expr ',' expr",
"expr : '-' expr",
"expr : '+' expr",
"expr : INC VARIABLE",
"expr : DEC VARIABLE",
"expr : VARIABLE INC",
"expr : VARIABLE DEC",
"expr : '!' expr",
"expr : '~' expr",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '&' expr",
"expr : expr '|' expr",
"expr : expr '^' expr",
"expr : expr SHL expr",
"expr : expr SHR expr",
"expr : expr POWER expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : expr IDN expr",
"expr : expr DIF expr",
"expr : expr '<' expr",
"expr : expr LEQ expr",
"expr : expr '>' expr",
"expr : expr GEQ expr",
"expr : expr '?' expr ':' expr",
"expr : VARIABLE '=' expr",
"expr : VARIABLE PLEQ expr",
"expr : VARIABLE MIEQ expr",
"expr : VARIABLE MULEQ expr",
"expr : VARIABLE DIVEQ expr",
"expr : VARIABLE MODEQ expr",
"expr : VARIABLE ANDEQ expr",
"expr : VARIABLE XOREQ expr",
"expr : VARIABLE OREQ expr",
"expr : VARIABLE",
"expr : Y_NUMBER",
"expr : '(' expr ')'",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 228 "expr.y"

char* atoh(char* s, double* r)
{
	register short c;

	*r = (double)0;
	while (isxdigit(c = *s)) {
		*r *= 0x10;
		*r += isdigit(c) ? c - '0' : tolower(c) - 'a' + 0xa;
		++s;
	}
	return s;
}

#define plural(c,fc,sc,id)		\
	if ((c) == (fc)) {	\
		if (((c) = *eval_s++) == (sc))	{\
			printf("detected %c%c\n", (fc), (sc)); \
			return id;	\
		} \
		else {	\
			--eval_s;	\
			printf("detected %c\n", (fc)); \
			return fc;	\
		}	\
	}
#define plural3(c,fc,sc,id1,tc,id2) \
	if ((c) == (fc)) { \
		if (((c) = *eval_s++) == (sc)) \
			return id1; \
		else if ((c) == (tc)) \
			return id2; \
		else { \
			--eval_s; \
			return fc; \
		} \
	}

int	yylex(void)
{
	if (eval_end)
		//return YYEOF;
		return EOF;
	else {
		int	c;
		do {
			c = *eval_s++;
			if (isalpha(c) || c == '_') {
				static char buff[1024];		// ꂾƂƂΑv낤
				char *p = buff;
				yylval.name = buff;
				eval_s--;
				do {
					*p++ = *eval_s++;
				} while (isalnum(*eval_s) || *eval_s == '_');
				*p = '\0';
				yylval.name = xstrdup(buff);
				return VARIABLE;
			}else if (isdigit(c)) {
				if (c == '0' && tolower(*eval_s) == 'x') {
					++eval_s;
					/* skimp.... */
					eval_s = atoh(eval_s, &yylval.value);
				}else{
					yylval.value = atof(--eval_s);
				}

				{
					BOOL point = FALSE;
					BOOL exp = FALSE;
					#define FORM_ERR	"_̃tH[}bgႢ܂"
					for (; isdigit(*eval_s); ++eval_s) {
						if (eval_s[1] == '.') {
							++eval_s;
							if (point || exp) {
								yyerror(FORM_ERR);
							}else{
								point = TRUE;
							}
						}else if (tolower(eval_s[1]) == 'e') {
							eval_s += 2;
							if (exp) {
								yyerror(FORM_ERR);
							}else{
								exp = TRUE;
								if (*eval_s != '+' && *eval_s != '-') {
									yyerror(FORM_ERR);
								}
							}
						}
					}
				}
				return Y_NUMBER;
			}
			else plural3(c, '*', '*', POWER, '=', MULEQ)
			else plural3(c, '<', '<', SHL, '=', LEQ)
			else plural3(c, '>', '>', SHR, '=', GEQ)
			else plural3(c, '+', '+', INC, '=', PLEQ)
			else plural3(c, '-', '-', DEC, '=', MIEQ)
			else plural3(c, '&', '&', AND, '=', ANDEQ)
			else plural3(c, '|', '|', OR, '=', OREQ)
			else plural(c, '=', '=', IDN)
			else plural(c, '!', '=', DIF)
			else plural(c, '/', '=', DIVEQ)
			else plural(c, '%', '=', MODEQ)
			else plural(c, '^', '=', XOREQ)
			else if (c == '\0') {
				eval_end = 1;
				return EOL;
			}
		} while (isspace(c)) ;
		return c;
	}
}

double* evaluate(char *s)
{
	extern int yyparse();

	acc = (double)0;
	var_assigned = FALSE;
	no_err = TRUE;
	if (s == NULL)
		return NULL;
	eval_end = 0;
	eval_s = s;
	yyparse();
	xstrfree();
	acc = eval_val;
	if (!no_err)
		return NULL;
	return &acc;
}
#line 612 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 3:
#line 145 "expr.y"
{ 
				eval_val = yyvsp[-1].value; 
			}
break;
case 4:
#line 148 "expr.y"
{ yyerrok; }
break;
case 5:
#line 152 "expr.y"
{ var_assigned = FALSE; yyval.value = yyvsp[0].value; }
break;
case 6:
#line 153 "expr.y"
{ yyval.value = -yyvsp[0].value; }
break;
case 7:
#line 154 "expr.y"
{ yyval.value = yyvsp[0].value; }
break;
case 8:
#line 156 "expr.y"
{ yyval.value = preinc(yyvsp[0].name); }
break;
case 9:
#line 157 "expr.y"
{ yyval.value = predec(yyvsp[0].name); }
break;
case 10:
#line 158 "expr.y"
{ yyval.value = postinc(yyvsp[-1].name); }
break;
case 11:
#line 159 "expr.y"
{ yyval.value = postdec(yyvsp[-1].name); }
break;
case 12:
#line 161 "expr.y"
{ yyval.value = !(yyvsp[0].value); }
break;
case 13:
#line 162 "expr.y"
{ yyval.value = not(yyvsp[0].value); }
break;
case 14:
#line 164 "expr.y"
{ yyval.value = yyvsp[-2].value + yyvsp[0].value; }
break;
case 15:
#line 165 "expr.y"
{ yyval.value = yyvsp[-2].value - yyvsp[0].value; }
break;
case 16:
#line 166 "expr.y"
{ yyval.value = yyvsp[-2].value * yyvsp[0].value; }
break;
case 17:
#line 167 "expr.y"
{ yyval.value = yyvsp[-2].value / yyvsp[0].value; }
break;
case 18:
#line 168 "expr.y"
{ yyval.value = mod(yyvsp[-2].value, yyvsp[0].value); }
break;
case 19:
#line 169 "expr.y"
{ yyval.value = and(yyvsp[-2].value, yyvsp[0].value); }
break;
case 20:
#line 170 "expr.y"
{ yyval.value = or(yyvsp[-2].value, yyvsp[0].value); }
break;
case 21:
#line 171 "expr.y"
{ yyval.value = xor(yyvsp[-2].value, yyvsp[0].value); }
break;
case 22:
#line 172 "expr.y"
{ yyval.value = shl(yyvsp[-2].value, yyvsp[0].value); }
break;
case 23:
#line 173 "expr.y"
{ yyval.value = shr(yyvsp[-2].value, yyvsp[0].value); }
break;
case 24:
#line 175 "expr.y"
{ yyval.value = power(yyvsp[-2].value, yyvsp[0].value); }
break;
case 25:
#line 177 "expr.y"
{ yyval.value = yyvsp[-2].value && yyvsp[0].value; }
break;
case 26:
#line 178 "expr.y"
{ yyval.value = yyvsp[-2].value || yyvsp[0].value; }
break;
case 27:
#line 179 "expr.y"
{ yyval.value = yyvsp[-2].value == yyvsp[0].value; }
break;
case 28:
#line 180 "expr.y"
{ yyval.value = yyvsp[-2].value != yyvsp[0].value; }
break;
case 29:
#line 181 "expr.y"
{ yyval.value = yyvsp[-2].value < yyvsp[0].value; }
break;
case 30:
#line 182 "expr.y"
{ yyval.value = yyvsp[-2].value <= yyvsp[0].value; }
break;
case 31:
#line 183 "expr.y"
{ yyval.value = yyvsp[-2].value > yyvsp[0].value; }
break;
case 32:
#line 184 "expr.y"
{ yyval.value = yyvsp[-2].value >= yyvsp[0].value; }
break;
case 33:
#line 185 "expr.y"
{ 
				if (yyvsp[-4].value)
					yyval.value = yyvsp[-2].value;
				else
					yyval.value = yyvsp[0].value;
			}
break;
case 34:
#line 191 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, yyvsp[0].value);
			}
break;
case 35:
#line 194 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, eval_variable(yyvsp[-2].name) + yyvsp[0].value);
			}
break;
case 36:
#line 197 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, eval_variable(yyvsp[-2].name) - yyvsp[0].value);
			}
break;
case 37:
#line 200 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, eval_variable(yyvsp[-2].name) * yyvsp[0].value);
			}
break;
case 38:
#line 203 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, eval_variable(yyvsp[-2].name) / yyvsp[0].value);
			}
break;
case 39:
#line 206 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, mod(eval_variable(yyvsp[-2].name), yyvsp[0].value));
			}
break;
case 40:
#line 209 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, and(eval_variable(yyvsp[-2].name), yyvsp[0].value));
			}
break;
case 41:
#line 212 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, xor(eval_variable(yyvsp[-2].name), yyvsp[0].value));
			}
break;
case 42:
#line 215 "expr.y"
{
				yyval.value = assign_variable(yyvsp[-2].name, or(eval_variable(yyvsp[-2].name), yyvsp[0].value));
			}
break;
case 43:
#line 218 "expr.y"
{
				yyval.value = eval_variable(yyvsp[0].name);
			}
break;
case 44:
#line 221 "expr.y"
{ }
break;
case 45:
#line 222 "expr.y"
{
				 yyval.value = yyvsp[-1].value;
		}
break;
#line 953 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
